## crash 7.2.3+real

=== debian/changelog ===
crash (7.2.3+real-1~16.04.1) xenial; urgency=medium

  * Backport to xenial. LP: #1746088
    - Build-Depends on debhelper 9.

 -- Thadeu Lima de Souza Cascardo <cascardo@canonical.com>  Tue, 26 Jun 2018 14:32:30 -0300

crash (7.2.3+real-1) unstable; urgency=medium

  * Revert wget addition and re-include embedded gdb (Closes: #901863)

 -- Troy Heber <troyh@debian.org>  Fri, 22 Jun 2018 15:39:16 -0600

crash (7.2.3-2) unstable; urgency=medium

  * Add wget as a builddep

 -- Troy Heber <troyh@debian.org>  Tue, 22 May 2018 09:16:03 -0600

crash (7.2.3-1) unstable; urgency=medium

  * Fix for a crash-7.2.2 regression that may cause the "mount" command to
    generate a segmentation violation.  The bug is dependent upon the compiler
    version used to build the crash utility, where a buffer overrun is not
    seen with more recent versions of gcc, which hide the bug due to a
    different stack layout of a function's local variables.

  * Fix for a second crash-7.2.2 buffer overrun regression that may cause the
    "rd -S" option to generate a segmentation violation if a displayed memory
    location contains a slab object address.

  * Fix for a third, highly unlikely, crash-7.2.2 buffer overrun regression,
    that could potentially occur during session initialization.

 -- Troy Heber <troyh@debian.org>  Mon, 21 May 2018 14:01:30 -0600

crash (7.2.2-1) UNRELEASED; urgency=medium

  * Fix to support Linux 4.16-rc1 and later ARM64 kernels, which fail during
    session initialization with the error message "crash: cannot determine
    page size".  The failure to determine the page size is due to the
    combination of the following kernel commits: - Linux 4.6 commit
    6ad1fe5d9077a1ab40bf74b61994d2e770b00b14 arm64: avoid R_AARCH64_ABS64
    relocations for Image header fields - Linux 4.10 commit
    4b65a5db362783ab4b04ca1c1d2ad70ed9b0ba2a arm64: Introduce
    uaccess_{disable,enable} functionality based on TTBR0_EL1 - Linux 4.16
    commit 1e1b8c04fa3451e2b7190930adae43c95f0fae31 arm64: entry: Move the
    trampoline to be before PAN

  * Fix the search for the booted kernel on a live system to prevent selecting
    the unusable "vmlinux.o" file found in private build directories.  Without
    the patch, the non-executable vmlinux.o file may be selected, and the
    resulting fatal error message indicates a somewhat misleading "crash:
    cannot resolve _stext".

  * Implemented a new "ps -A" option that restricts the task output to just
    the active tasks on each cpu.

  * As the first step in optimizing the is_page_ptr() function, save the
    maximum SPARSEMEM section number during initialization, and use it as the
    topmost delimeter in subsequent mem_section searches.  Also allow for
    per-architecture machdep->is_page_ptr() plugin functions.

  * Implemented the x86_64 machdep->is_page_ptr() plugin function.  If the
    kernel is configured with CONFIG_SPARSEMEM_VMEMMAP, the plugin function
    optimizes the mem_section search, reducing the computation effort and time
    consumed by commands that repeatedly call the is_page_ptr() function on
    large-memory systems.

  * Fixes for 32-bit X86 "bt" command on kernels that have been compiled with
    retpoline gcc support.  Without the patch, backtraces may fail with the
    error message "bt: cannot resolve stack trace", followed by the text
    symbols found on the stack and possible exception frames.

  * Fix the "help foreach" argument list to include the new "gleader" task
    qualifier option that was added in version 7.1.2.

  * VMware VMSS dumpfiles contain the state of each vCPU at the time when the
    VM was suspended.  This patch enables crash to read the relevant registers
    from each vCPU state for use as the starting hooks by the "bt" command.
    Also, support for "help -[D|n]" to display dumpfile contents, and "help
    -r" to display vCPU register sets has been implemented.  This is also the
    first step towards implementing automatic KASLR offset calculations for
    VMSS dumpfiles.

  * Commit 45b74b89530d611b3fa95a1041e158fbb865fa84 added support for
    calculating phys_base and the mapped kernel offset for KASLR-enabled
    kernels on SADUMP dumpfiles by using a technique developed by Takao Indoh.
    Originally, the patchset included support for kdumps, but this was dropped
    in v2, as it was deemed unnecessary due to the upstream implementation of
    the "vmcoreinfo device" in QEMU.  However, there are still several reasons
    for which the vmcoreinfo device may not be present at the time when a
    memory dump is taken from a VM, ranging from a host running older
    QEMU/libvirt versions, to misconfigured VMs or environments running
    Hypervisors that doesn't support this device.  This patchset generalizes
    the KASLR-related functions from sadump.c and moves them to
    kaslr_helper.c, and makes kdump analysis fall back to KASLR offset
    calculation if vmcoreinfo data is missing.

  * Fix for the "bt" command on 4.16 and later kernels size in which the
    "thread_union" data structure is not contained in the vmlinux file's
    debuginfo data.  Without the patch, the kernel stack size is not
    calculated correctly, and defaults to 8K.  As a result "bt" fails with the
    message "bt: invalid RSP: <address> bt->stackbase/stacktop:
    <address>/<address> cpu: <number>".

  * Fix for the x86_64 "bt" command for kernels that are configured with
    CONFIG_FRAME_POINTER.  Without the patch, the per-text-return-address
    framesize cache may contain invalid entries for functions that have an
    "and $0xfffffffffffffff0,%rsp" instruction in their prologue, which aligns
    the stack on a 16-byte boundary; therefore any cached framesize for a
    text-return-address in such a function may be incorrect depending upon the
    alignment of the stack address of a calling function.  If an invalid
    cached framesize is utilized by "bt", the backtrace may skip over several

