=== debian/changelog ===
crash (7.2.5-1) unstable; urgency=medium

  * New upstream (Closes: #919291)

  * Resurrection of the "dev -p" option for displaying PCI device data on
    Linux 2.6.26 and later kernels.  The option was deprecated as of Linux
    2.6.26, and without the patch, the option would indicate "dev: -p option
    not supported or applicable on this architecture or kernel" when running
    against the newer kernel versions.  PCI Bus information will also be
    displayed with this patch.

  * With Linux 4.19-rc1 commit 7d4340bb92a9df78e6e28152f3dd89d9bd82146b,
    titled "powerpc/mm: Increase MAX_PHYSMEM_BITS to 128TB with
    SPARSEMEM_VMEMMAP config", the PPC64 MAX_PHYSMEM_BITS value has been
    bumped up to 47.  The appropriate update has been made in this patch.

  * Fix to allow piping command output to a shell script beginning with a
    shebang (#!) character sequence if the script pathname is specified with a
    preceding "./" or "/".  Without the patch, the piped command fails with
    the message "crash: pipe operation failed".

  * Fix for the PPC64 "bt" command to recognize when a thread is running in
    OPAL firmware.  Without the patch, the "bt" command indicates
    <task-address>: Invalid Stack Pointer <OPAL-firmware-address>"

  * As an addendum to the "dev -p" patch above, add the new structure member
    offsets for display by the "help -o" option.

  * Enhancement to the "kmem -n" option to dump memory block information if
    the kernel supports it.  In addition, the memory section data block has a
    new "STATE" column added to it.

  * Addendum to the previous "kmem -n" patch to fix a FTBFS issue.   Without
    the patch, certain architectures fail to compile with the error
    "memory.c:17315:16: error: ‘PAGE_SHIFT’ undeclared (first use in this
    function)"

  * Fix the calculation of the vmalloc memory region size to account for Linux
    4.17 commit a7412546d8cb5ad578805060b4006f2a021b5868, titled "x86/mm:
    Adjust vmalloc base and size at boot-time", which increases the region's
    size from 32TB to 1280TB when 5-level pagetables are enabled.  Also
    presume that virtual addresses above the end of the vmalloc space up to
    the beginning of vmemmap space are translatable via 5-level page tables.
    Without the patch, mapped virtual addresses may fail translation in
    whatever command accesses them, with errors indicating "seek error: kernel
    virtual address: <mapped-address>  type: <type-string>"

  * Address several Coverity Scan "RESOURCE_LEAK" issues in the following
    top-level source files: cmdline.c, kvmdump.c, lkcd_v8.c, xendump.c,
    symbols.c, unwind_x86_32_64.c, va_server.c and va_server_v1.c.

  * Modify the x86_64 "bt" behavior when a legitimate exception RIP value
    cannot be referenced symbolically, such as when the exception occurs while
    running in seccomp BPF filter code.  Without the patch, the exception
    frame register dump is preceded by "[exception RIP: unknown or invalid
    address]", and then followed by "bt: WARNING: possibly bogus exception
    frame".  With the patch applied, the translation of the exception RIP will
    show "[exception RIP: no symbolic reference]", and there will be no
    warning message.

  * Account for the /proc/kcore VMCOREINFO PT_NOTE in Linux 4.19 and later
    kernels having commit 23c85094fe1895caefdd19ef624ee687ec5f4507, titled
    "proc/kcore: add vmcoreinfo note to /proc/kcore".  The PT_NOTE information
    is stored during session initialization for later display by "help
    -[n|D]"; a subsequent commit will make it available for use by the crash
    utility's internal pc->read_vmcoreinfo() function.

  * Second phase of support for the VMCOREINFO PT_NOTE added to the ELF header
    of /proc/kcore in Linux 4.19 and later kernels.  This patch introduces
    support for live session /proc/kcore VMCOREINFO access by the crash
    utility's internal pc->read_vmcoreinfo() function.  New usage include the
    initialization of the x86_64 phys_base value, and the arm64 phys_offset,
    page size, and VA bits count.

  * Fix for Linux 4.20-rc1 and later kernels that contain kernel commit
    5c83511bdb9832c86be20fb86b783356e2f58062, titled "x86/paravirt: Use a
    single ops structure".  Without the patch, the kernel may be misidentified
    as an ARCH_XEN kernel, with the most noticeable result being the inability
    to read vmemmap'd page structures.

  * Implemented the functionality for a new MEMBER_TYPE_NAME() macro, which
    will return a pointer to the type name string of a structure member.  It
    is being put in place for the support of Linux 4.20 radix tree to xarray
    replacements, where structure member types may be changed from
    radix_tree_root structures to xarray structures.

  * First phase of support for the XArray facility.  The added support is
    similar to that of radix trees, but introduces completely separate
    functions, structures and #defines.  None of the applicable radix tree
    users in the crash utility have been switched over, so this phase does not
    introduce any functional changes.

  * Second phase of support for the XArray facility, which handles the
    switch-over of PID handling from a radix tree to an XArray in Linux 4.20
    and later kernels.  Without the patch, the crash session fails during
    session initialization with the message "crash: radix trees do not exist
    or have changed their format".

  * Third phase of support for the XArray facility, which consolidates the
    radix_tree_pair and xarray_pair structures into a unified list_pair
    structure that is used by both facilities, and fixes the "bpf" command.
    Without the patch, the command fails on Linux 4.20 or later kernels with
    the error message "bpf: radix trees do not exist or have changed their
    format".

  * Added support for usage of the XArray facility by the "files -p" option.

