## crash 7.2.6

=== debian/changelog ===
crash (7.2.6-1build1) eoan; urgency=medium

  * No-change upload with strops.h and sys/strops.h removed in glibc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2019 10:47:07 +0000

crash (7.2.6-1) unstable; urgency=medium

  * Two fixes for the Xen hypervisor; the first fixes a bug seen with Xen
    4.11.0 during initialization, which fails with the error message "crash:
    invalid kernel virtual address: <address> type: fill_pcpu_struct",
    followed by "WARNING: cannot fill pcpu_struct" and "crash: cannot read
    cpu_info".  The second fix prevents a segmentation violation associated
    with a crash-7.1.1 commit that addressed the Xen 4.5.0 hypervisor symbol
    name change from "dom0" to "hardware_domain".

  * Fix for Linux 4.20 and later x86_64 kernels which are NOT configured with
    CONFIG_RANDOMIZE_BASE.  Linux 4.20 introduced kernel commit
    d52888aa2753e3063a9d3a0c9f72f94aa9809c15, titled "x86/mm: Move LDT remap
    out of KASLR region on 5-level paging", which modified the 4-level and
    5-level paging PAGE_OFFSET values.  Without this patch, the crash session
    fails during initialization with the error message "crash: read error:
    kernel virtual address: <address>  type: tss_struct ist array".  For
    kernels prior to Linux 4.20.0 which have backports of the kernel commit,
    the kernel's PAGE_OFFSET value must be manually specified via the command
    line option "--machdep page_offset=ffff888000000000" for kernels with
    4-level page tables, or "--machdep page_offset=ff11000000000000" for
    kernels with 5-level paging.  (or alternatively the shorter version "-m
    page_offset=<address>" may be used).  The command line option requirement

  * Fix for the "p" command if the expression contains more than one opening
    parenthesis character and a minus/dash sign.  Without the patch, the
    minus/dash sign will get dropped from the command prior to it being passed
    on to gdb for evaluation, and the command will fail with the message "p:
    gdb request failed: <expression>", where the <expression> string will not

  * Fix for the internal parse_line() utility function to account for embedded
    sets of parentheses, which may be used for expressions that are passed to
    gdb by the "p" command.  Without the patch, expressions containing
    embedded sets of parentheses are broken up into multiple argument tokens
    instead of just one.  The previous commit has been reverted by this one.

  * First phase of support for ARM64 kernels that are configured with
    CONFIG_ARM64_USER_VA_BITS_52, which causes the PTRS_PER_PGD count to
    increase from 64 to 1024.  Without the patch, "WARNING: cannot access
    vmalloc'd module memory" will be displayed during session initialization,
    and the translation of any mapped kernel virtual address that requires a
    page table walk will fail, leading to a myriad of other errors.

  * Support for configurable CONFIG_ARM64_PA_BITS values introduced in kernel
    commit 982aa7c5f0861bf56b2412ca341a13f44c238ba4, titled "arm64: add
    kconfig symbol to configure physical address size".  Without the patch, it
    is impossible to determine the value of CONFIG_ARM64_PA_BITS is, and will
    require a new MAX_PHYSMEM_BITS vmcoreinfo entry to be exported.  This

  * For live system analysis where there is no vmcoreinfo ELF note attached to
    /proc/kcore, or for dumpfile analysis where there is no vmcoreinfo ELF
    note attached to the dumpfile, this patch sets the internal
    pc->read_vmcoreinfo() function to a new plugin function that reads the
    data directly from the live kernel or dumpfile.  Because the function is
    set much later during initialization than if the ELF note is attached to
    /proc/kcore or the dumpfile, it may not be available during very early

  * Fix for Linux 4.14.84 and later 4.14-based x86_64 kernels which are NOT
    configured with CONFIG_RANDOMIZE_BASE and have backported kernel commit
    d52888aa2753e3063a9d3a0c9f72f94aa9809c15, titled "x86/mm: Move LDT remap
    out of KASLR region on 5-level paging", which modified the 4-level and
    5-level paging PAGE_OFFSET values.  Without this patch, the crash session
    fails during initialization with the error message "crash: read error:
    kernel virtual address: <address>  type: tss_struct ist array".

  * Fix for determining the x86_64 "phys_base" value in dumpfiles created by
    the KVM "virsh dump" facility if the kernel is KASLR-enabled and does not
    have the phys_base value stored in vmcoreinfo data.  Without the patch,
    the message "WARNING: cannot determine physical base address: defaulting
    to 0" is displayed, and the crash session fails to initialize.

  * 32-bit ARM kernels built with the Thumb-2 instruction set utilize the R7
    register instead of FP for unwinding stacks using the DWARF unwinder.  On
    those kernels, without the patch, the "bt" command only shows the task

  * Fix for the "kmem -z" option on Linux 5.0 and later kernels that contain
    commit a921444382b49cc7fdeca3fba3e278bc09484a27, titled "mm: move zone
    watermark accesses behind an accessor".  Without the patch, the command
    fails with the error message "kmem: invalid (optional) structure member
    offsets: zone_pages_min or zone_struct_pages_min".

  * Fix for the "kmem -i" option on Linux 5.0 and later kernels that contain
    commit ca79b0c211af63fa3276f0e3fd7dd9ada2439839 titled "mm: convert
    totalram_pages and totalhigh_pages variables to atomic".  Without the
    patch, the command prints some incorrect values, and besides does not
    print high/low memory information on kernels which are configured with

  * Fix for the display of kernel module symbol types by the "sym" command in
    Linux 5.0 and later kernels if the module debuginfo data has not been
    loaded into the crash session.  The st_info member of the Elf32_Sym or
    Elf64_Sym structures has changed so as to not contain ASCII symbol type

