=== debian/changelog ===
crash (7.2.8-1ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Update the maintainer field for Ubuntu.
    - If the "live" autopkgtest fails with a recommendation to try
      /proc/kcore instead of the default, attempt that before failing
      the test. LP: #1858958.
  * Fix test, as if will return 0 when no cases were true.

 -- Thadeu Lima de Souza Cascardo <cascardo@canonical.com>  Wed, 12 Feb 2020 22:12:51 +0000

crash (7.2.8-1) unstable; urgency=medium

  * New upstream (Closes: #950544)

  * Fix for Linux 5.4-rc1 and later kernels that contain commit
    688fcbfc06e4fdfbb7e1d5a942a1460fe6379d2d, titled "mm/vmalloc: modify
    struct vmap_area to reduce its size".  Without the patch "kmem -v" will
    display nothing; other architectures that utilize the vmap_area_list to
    determine the base of mapped/vmalloc address space will fail.

  * Fix for Linux 5.4-rc1 and later kernels that contain commit/merge
    e0703556644a531e50b5dc61b9f6ea83af5f6604, titled "Merge tag 'modules-
    for-v5.4' of git://git.kernel.org/pub/scm/linux/kernel/git/jeyu/linux
    which introduces symbol namespaces.  Without the patch, and depending upon
    the architecture:
    (1) the kernel module symbol list will contain garbage entries
    (2) the session fails during session initialization with a dump of
       the internal buffer allocation stats followed by the message
       "crash: cannot allocate any more memory!"
    (3) the session fails during session initialization with a
       segmentation violation.

  * Fix for the "timer -r" option on Linux 5.4-rc1 and later kernels that
    contain commit 511885d7061eda3eb1faf3f57dcc936ff75863f1, titled
    "lib/timerqueue: Rely on rbtree semantics for next timer".  Without the
    patch, the option fails with the following error "timer: invalid structure
    member offset: timerqueue_head_next".

  * Fix for a "[-Wstringop-truncation]" compiler warning emitted when
    symbols.c is built in a Fedora Rawhide environment with gcc-9.0.1 or
    later.

  * Fix for the "kmem -n" option on Linux-5.4-rc1 and later kernels that
    contain commit b6c88d3b9d38f9448e0fcf44847a075ea81d5ca2, titled
    "drivers/base/memory.c: don't store end_section_nr in memory blocks".
    Without the patch, the command option fails with the error message "kmem:
    invalid structure member offset: memory_block_end_section_nr".

  * Fix for Linux 4.19.5 and later 4.19-based x86_64 kernels which are NOT
    configured with CONFIG_RANDOMIZE_BASE and have backported kernel commit
    d52888aa2753e3063a9d3a0c9f72f94aa9809c15, titled "x86/mm: Move LDT remap
    out of KASLR region on 5-level paging", which modified the 4-level and
    5-level paging PAGE_OFFSET values.  Without this patch, the crash session
    fails during initialization with the error message "crash: seek error:
    kernel virtual address: <address> type: "tss_struct ist array".

  * Additional fix for the "kmem -n" option on Linux-5.4-rc1 and later kernels
    that contain commit b6c88d3b9d38f9448e0fcf44847a075ea81d5ca2, titled
    "drivers/base/memory.c: don't store end_section_nr in memory blocks".  The
    initial fix only addressed the x86_64 architecture; this incremental patch
    addresses the other architectures.

  * In the unlikely event that the panic task in a dumpfile cannot be
    determined by the normal means, scan the kernel log buffer for panic
    keywords, and if found, generate the panic task from the CPU number that
    is specified following the panic message.

  * Adjust a crash-7.1.8 patch for support of /proc/kcore as the live memory
    source in Linux 4.8 and later x86_64 kernels configured with
    CONFIG_RANDOMIZE_BASE, which randomizes the unity-mapping PAGE_OFFSET
    value.  Since the problem only arises before the determination of the
    randomized PAGE_OFFSET value, restrict the patch such that it only takes
    effect during session initialization.

  * Add support for extended numbering support in ELF dumpfiles to handle more
    than PN_XNUM (0xffff) program headers.  If the real number of program
    header table entries is equal to or greater than PN_XNUM, the e_phnum
    field of the ELF header is set to PN_XNUM, and the actual number is set in
    the sh_info field of the section header at index 0.

  * Fix for a "warning: large integer implicitly truncated to unsigned type
    [-Woverflow]" compiler message generated on 32-bit architectures as a
    result of the "Additional fix for the kmem -n option" patch above.

  * Add support for handling openSUSE vmlinux files which will be shipped in
    .xz compressed format.  Without the patch, only gzip and bzip2 formats are
    supported.

  * Fix for the determination of the ARM64 page size on Linux 4.4 and earlier
    kernels that do not have vmcoreinfo data.  Without the patch, the crash
    session fails during initialization with the error message "crash: "cannot
    determine page size".

  * Determine the ARM64 kernel's "vabits_actual" value by reading the new
    TCR_EL1.T1SZ vmcoreinfo entry.

  * Fix to determine the ARM64 kernel's "vabits_actual" value from the ELF
    header of a dumpfile created with the "snap.so" extension module.

  * Fix two typos in the examples section of the "help bt" display, which
    mistakenly show "bf -f" and "bf -FF" instead of "bt -f" and "bt -FF".

  * Similar to ARM64, the X86_64, PPC64 and S390x architectures will use the
    exported value of MAX_PHYSMEM_BITS from the vmcoreinfo data as the
    preferred method if it is available.

  * If an S390X kernel crashes before vmcoreinfo initialization, there is no
    way to extract the KASLR offset for such early dumps.  In a new S390X
    kernel patch, the KASLR offset will be stored in the lowcore memory during
    early boot and then overwritten after vmcoreinfo is initialized.  This
    patch allows crash to identify the KASLR offset that is stored in the
    lowcore memory.


