=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: crash
 Section: utils
 Priority: optional
-Maintainer: Troy Heber <troyh@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Troy Heber <troyh@debian.org>
 Uploaders:
 Build-Depends: debhelper (>= 10), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
-Standards-Version: 4.3.0.0
+Standards-Version: 4.5.0.0
 XS-Testsuite: autopkgtest
 
 Package: crash
