## crash 7.2.8-1+cl4u1

=== Makefile ===
--- 
+++ 
@@ -269,11 +269,9 @@
 	if [ "${ARCH}" = "x86_64" ] && [ "${TARGET}" = "PPC64" ] && [ -f ${GDB}-ppc64le-support.patch ]; then \
 		patch -d ${GDB} -p1 -F0 < ${GDB}-ppc64le-support.patch ; \
 	fi
-	if [ -f /usr/include/proc_service.h ]; then \
-		grep 'extern ps_err_e ps_get_thread_area (struct' /usr/include/proc_service.h; \
-		if [ $$? -eq 0 ]; then \
-			patch -p0 < ${GDB}-proc_service.h.patch; \
-		fi; \
+	if echo '#include <proc_service.h>' | ${CC} -E - | \
+			grep -q 'extern ps_err_e ps_get_thread_area (struct'; then \
+		patch -p0 < ${GDB}-proc_service.h.patch; \
 	fi
 
 library: make_build_data ${OBJECT_FILES}
@@ -294,3 +292,4 @@
 	@./configure ${CONF_TARGET_FLAG} -q -b
 	@make --no-print-directory do_clean
 
+do_clean:
