=== debian/changelog ===
crash (7.2.8-1+cl4u1) CumulusLinux-4; urgency=medium

  [ Benjamin Poirier ]
  * CUMULUS: Apply debian/patches/0001-dont-git-clone-eppic-extension.patch
  * CUMULUS: Apply debian/patches/0002-multiarch-libc.patch
  * CUMULUS: debian: Change source package format to "3.0 (git)"
  * CUMULUS: Search for kernel version in uts version string
  * CUMULUS: debian: Add changelog entry for 7.2.8-1+cl4u1
  * CUMULUS: Force host arch for gdb build

  [ Timothy Lee ]
  * Prevent extensions, lzo, and snappy from being made in parallel.

 -- Cumulus Networks <dev-support@cumulusnetworks.com>  Wed, 03 Jun 2020 09:37:20 +0900
